#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <string.h>
#include <unistd.h>

#define BUFF_SIZE 1000




struct PageWeb
{
	int size;
	char* html_contents;
};




void freePage(struct PageWeb** page)
{
	if(*page!=NULL)
	{
		if((*page)->html_contents!=NULL) free((*page)->html_contents);
		free(*page);
	}
}



void getWeb(char* pageName, struct PageWeb** page)
{
	*page=malloc(sizeof(struct PageWeb));

	FILE* pageFile=fopen(pageName, "r+");

	if(pageFile!=NULL)
	{
		fseek(pageFile, 0L, SEEK_END);
		long nbr_char=ftell(pageFile);
		fseek(pageFile, 0L, SEEK_SET);


		(*page)->html_contents=malloc(nbr_char*sizeof(char));
		fread(((*page)->html_contents),1,nbr_char,pageFile);

		(*page)->size=strlen(((*page)->html_contents));
		fclose(pageFile);
	}
	else
	{
		char erreur[]="<h1> 404 PAGE NOT FOUND </h1>\r\n\r\n La page que vous cherchez n'a pas été trouvée, sans doute parce que vous êtes nul.";
		(*page)->html_contents=malloc(strlen(erreur)*sizeof(char));
		strcpy((*page)->html_contents, erreur);
	}
	
}




void* reponseConnexion(void* sock)
{	
	printf("Connected\n"); // Affiche le fait que qqn soit connecté

	struct PageWeb* page; 

	getWeb("../Sioux/Page.html", &page);

	char buff_rec[BUFF_SIZE];
	char buffer[BUFF_SIZE];

	strcat(buffer,"HTTP/1.1 200 OK\r\nServer: Serveur fait maison\r\nContent-Type: text/html; charset=UTF-8\r\nConnection: Keep-alive\r\n\r\n");
	strcat(buffer, page->html_contents);

	freePage(&page);

	FILE* sockdial_stream = fdopen(*((int*)(sock)), "a+");
	
	printf("Sock : %d // Stream : %p \n", *((int*)(sock)), sockdial_stream);
	
	fprintf(sockdial_stream, "%s", buffer);
	
	printf("WAIT\n");

	fgets(buff_rec, BUFF_SIZE, sockdial_stream);
	
	printf("Le message reçu : %s", buff_rec);

	fprintf(sockdial_stream, "Ceci est une réponse du serveur TCP.\n");

	strcpy(buffer, "START");	
	printf("Fin de la connexion\n");
	fclose(sockdial_stream);
	pthread_exit(NULL);
}




int lanceThread(void(* fonction) (void *), void* arg, int size)
{
	pthread_t thr_id;
	printf("%d \n",size);	
	if(pthread_create(&thr_id, NULL, (void*)fonction, arg )!=0) { fprintf(stderr, "Le thread n'a pas pu être créé.\n"); return -1; }
	
	pthread_detach(thr_id);

	return 0;
}



